// these structures were auto-generated using /builddir/build/BUILD/opae-2.2.0-1/libraries/scripts/ofs/ofs_parse.py
// modification of these structures may break the software

#ifndef __ofs_cpeng__
#define __ofs_cpeng__
#include <opae/fpga.h>
#include <ofs/ofs.h>

#ifdef __cplusplus
extern "C" {
#endif

// CE Feature DFH
#define CE_FEATURE_DFH_OFFSET 0x0
typedef union _CE_FEATURE_DFH {
  uint64_t value;
  struct {
    uint64_t f_FeatureRev : 4;
    // Feture Revision

    uint64_t f_NextDfhByteOffset : 24;
    // Next DFH Byte offset

    uint64_t f_EndOfList : 1;
    // End Of List

    uint64_t f_Reserved : 19;
    // Reserved

    uint64_t f_FeatureID : 19;
    // Feature ID

    uint64_t f_FeatureType : 4;
    // Feature Type = AFU
  };
} CE_FEATURE_DFH;

// CE Feature GUID_L
#define CE_FEATURE_GUID_L_OFFSET 0x8
typedef union _CE_FEATURE_GUID_L {
  uint64_t value;
  struct {
    uint64_t f_CE_ID_L : 64;
    // Lower 64-bit of feature GUID
  };
} CE_FEATURE_GUID_L;

// CE Feature GUID_H
#define CE_FEATURE_GUID_H_OFFSET 0x10
typedef union _CE_FEATURE_GUID_H {
  uint64_t value;
  struct {
    uint64_t f_CE_ID_H : 64;
    // Upper 64-bit of feature GUID
  };
} CE_FEATURE_GUID_H;

// CE Feature CSR Address
#define CE_FEATURE_CSR_ADDR_OFFSET 0x18
typedef union _CE_FEATURE_CSR_ADDR {
  uint64_t value;
  struct {
    uint64_t f_CSR_ADDR : 63;
    // CSR address Offset from start of DFH or absolute address to beginning of CSRs for this Feature or Interface

    uint64_t f_CSR_REL : 1;
    // 1'b0 = relative (offset from feature DFH start)
    // 1'b1 = absolute
  };
} CE_FEATURE_CSR_ADDR;

// CE Feature CSR Size group
#define CE_FEATURE_CSR_SIZE_GROUP_OFFSET 0x20
typedef union _CE_FEATURE_CSR_SIZE_GROUP {
  uint64_t value;
  struct {
    uint64_t f_GROUPING_ID : 31;
    // Used to group features / interfaces Logical grouping ID for features or interfaces.
    // All features or interfaces with the same ID will be assumed to be logically grouped together.
    // For instance, 2 channels each with a control and data interface have each pair specify a different ID.

    uint64_t f_HAS_PARAMS : 1;
    // Parameters exist or not 1 = Parameters follow this DFH block

    uint64_t f_CSR_SIZE : 32;
    // Size of CSR block in bytes  total CSR size
  };
} CE_FEATURE_CSR_SIZE_GROUP;

// Scratchpad register
#define CSR_HOST_SCRATCHPAD_OFFSET 0x100
typedef union _CSR_HOST_SCRATCHPAD {
  uint64_t value;
  struct {
    uint64_t f_HOST_SCRATCHPAD : 64;
    // Scratchpad register used during board bring up
  };
} CSR_HOST_SCRATCHPAD;

// Data request limit
#define CSR_CE2HOST_DATA_REQ_LIMIT_OFFSET 0x108
typedef union _CSR_CE2HOST_DATA_REQ_LIMIT {
  uint64_t value;
  struct {
    uint64_t f_DATA_REQ_LIMIT : 2;
    // 00: 64 Bytes
    // 01: 128 Bytes
    // 10: 512 Bytes
    // 11: 1024 Bytes
    // Default value is 1kB
    // This field depicts the maximum data request size by copy engine to host.

    uint64_t f_Reserved : 62;
    // Reserved
  };
} CSR_CE2HOST_DATA_REQ_LIMIT;

// Host DDR Address
#define CSR_SRC_ADDR_OFFSET 0x110
typedef union _CSR_SRC_ADDR {
  uint64_t value;
  struct {
    uint64_t f_CSR_SRC_ADDR : 32;
    // Host DDR Physical Address

    uint64_t f_Reserved : 32;
    // Reserved
  };
} CSR_SRC_ADDR;

// HPS DDR Offset
#define CSR_DST_ADDR_OFFSET 0x118
typedef union _CSR_DST_ADDR {
  uint64_t value;
  struct {
    uint64_t f_CSR_DST_ADDR : 32;
    // HPS DDR Offset or Destination Offset

    uint64_t f_Reserved : 32;
    // Reserved
  };
} CSR_DST_ADDR;

// Image size in bytes
#define CSR_DATA_SIZE_OFFSET 0x120
typedef union _CSR_DATA_SIZE {
  uint64_t value;
  struct {
    uint64_t f_CSR_DATA_SIZE : 32;
    // Data size in bytes
    // 0x00- Default Value
    // 0x01- 1 byte
    // 0x02 - 2 bytes
    // and so on

    uint64_t f_Reserved : 32;
    // Reserved
  };
} CSR_DATA_SIZE;

// Host DDR read start flag
#define CSR_HOST2CE_MRD_START_OFFSET 0x128
typedef union _CSR_HOST2CE_MRD_START {
  uint64_t value;
  struct {
    uint64_t f_MRD_START : 1;
    // Programmed by host to start host DDR memory read by copy engine
    // after programming CSR_SRC_ADDR, CSR_DST_ADDR and CSR_DATA_SIZE and DATA_REQ_LIMIT.
    // This bit can only be asserted by the SW.
    // De-assertion is always by the copy engine.
    // SW shouldn't write a zero to this field
    // Copy engine de-asserts this bit if CSR_CE2HOST_STATUS.CE_DMA_STS is 0b11 or 0b10

    uint64_t f_Reserved : 63;
    // Reserved
  };
} CSR_HOST2CE_MRD_START;

// DMA Status
#define CSR_CE2HOST_STATUS_OFFSET 0x130
typedef union _CSR_CE2HOST_STATUS {
  uint64_t value;
  struct {
    uint64_t f_CE_DMA_STS : 2;
    // Status of data movement from host to copy engine
    // 00-idle
    // 01-DMA in progress (Busy state)
    // 10-Successfully tranfered data from Host to HPS (data size as programmed in CSR_DATA_SIZE)
    // 11-Error in Transfer
    // This field gets updated for each descriptor programming.
    // When the copying is in progress, 0x1 is the status.
    // This field is marked successful only once the complete data as programmed in CSR_DATA_SIZE is transferred from Host to HPS
    // If any data packet is erroneous, this field is immediately mapped to 2'b11.
    // Host Software once seeing this field as 2'b11 can read bit[6, 4],
    // and bit[3, 2], of this CSR to know the source of error(AXI ST side or Acelite side)
    // Copy Engine expects a soft Reset if this field is 2'b11
    // Note: Once complete data as per CSR_DATA_SIZE is transferred,
    // copy engine will write '0' to CSR_HOST2CE_MRD_START.MRD_START

    uint64_t f_CE_ACELITE_BRESP_STS : 2;
    // 00 -OKAY
    // 01 - EXOKAY - Exclusive Access Okay
    // 10 - SLVERR - Slave Error
    // 11- DECERR - Decode Error
    // Acelite write response channle status for HPS DDR write.
    // Bit mapping is same as the 'BRESP' signal bit mapping of write response channel.
    // If the BRESP is not equal to 2'b00, copy engine treats as transfer failure.

    uint64_t f_CE_AXIST_CPL_STS : 3;
    // 000- Successful completion
    // 001- Unsupported request
    // 010- Reserved
    // 011- Reserved
    // 100- completer abort
    // 101- Reserved
    // 110- Reserved
    // 111- Reserved
    // Host DDR Read completion packet status at AXI Stream interface.
    // Bit mapping is same as 'completion status' field in the completion header format.
    // If the completion header packet has the status value other than '3'b000',
    // copy engine treats as unsuccessful completion.

    uint64_t f_CE_FIFO1_STS : 2;
    // FIFO1 Flow status
    // 00 - Reset value
    // 01 - FIFO1 underflow
    // 10 - FIFO1 overflow
    // 11 - FIFO1 underflow and FIFO overflow
    // Host SW should issue a soft reset to copy engine if overflow and or underflow happens

    uint64_t f_CE_FIFO2_STS : 2;
    // FIFO2 Flow status
    // 00 - Reset value
    // 01 - FIFO2 underflow
    // 10 - FIFO2 overflow
    // 11 - FIFO2 underflow and FIFO overflow
    // Host SW should issue a soft reset to copy engine if overflow and or underflow happens

    uint64_t f_CE_IMG_ADDR_STS : 2;
    // 00 - Reset value
    // 11 - Legal descriptor programming by host SW
    // 10 - Illegal descriptor programming by host SW
    // 11 - Reserved
    // This value is set to 1  by copy engine when the image source
    // address is programmed more than 32bits(>4GB) and or image destination
    // address is programmed more than 30bits(>1GB).
    // Copy engine will de-assert CSR_HOST2CE_MRD_START.MRD_START bit if illegal
    // value is programmed by host SW.
    // Host SW needs to reprogram the descriptors and set CSR_HOST2CE_MRD_START.MRD_START again.
    // This field gets self cleared. Copy engine soft reset is not required in the above case

    uint64_t f_Reserved : 51;
    // Reserved
  };
} CSR_CE2HOST_STATUS;

// DMA Done Flag
#define CSR_HOST2HPS_IMG_XFR_OFFSET 0x138
typedef union _CSR_HOST2HPS_IMG_XFR {
  uint64_t value;
  struct {
    uint64_t f_HOST2HPS_IMG_XFR : 1;
    // 0: Complete Image size not copied from Host to HPS
    // 1: Complete image size copied from Host to HPS.
    // HPS can start SSBL verification.

    uint64_t f_Reserved : 63;
    // Reserved
  };
} CSR_HOST2HPS_IMG_XFR;

// HPS Status
#define CSR_HPS2HOST_RSP_SHDW_OFFSET 0x140
typedef union _CSR_HPS2HOST_RSP_SHDW {
  uint64_t value;
  struct {
    uint64_t f_SSBL_VFY_SHDW : 2;
    // SSBL Verification
    // 00: reset value
    // 01: successful SSBL verification
    // 10: Erroneous
    // 11: Rsvd
    // The image that is downloaded from host includes the following:
    // *  Second Stage bootloader / uBoot
    // *  Linux kernel + rootFS (includes the 1588 application)
    // Host will send this complete package to HPS DDR using the copy engine
    // This field depicts the SSBL Verification status.
    // Once HPS sees host2hps_gpio (input to HPS) as high,
    // HPS can issue read to HPS DDR and then start SSBL verification

    uint64_t f_KERNEL_VFY_SHDW : 2;
    // Kernel Verification
    // 00: reset value
    // 01: successful Kernel verification
    // 10: Erroneous
    // 11: Rsvd
    // The image that is downloaded from host includes the following:
    // *  Second Stage bootloader / uBoot
    // *  Linux kernel + rootFS (includes the 1588 application)
    // Host will send this complete package to HPS DDR using the copy engine
    // This field depicts the Kernel verification status. Kernel verification is done after SSBL

    uint64_t f_HPS_RDY_SHDW : 1;
    // HPS Ready
    // HPS writes to this field once it is done with FSBL and ready to receive SSBL image.
    // HPS can program this bit only one time.
    // The first write to this field is expected as 1'b1.
    // No further programming will be allowed.

    uint64_t f_Reserved : 59;
    // Reserved
  };
} CSR_HPS2HOST_RSP_SHDW;

// Copy engine soft reset (active high)
#define CSR_CE_SFTRST_OFFSET 0x148
typedef union _CSR_CE_SFTRST {
  uint64_t value;
  struct {
    uint64_t f_CE_SFTRST : 1;
    // Copy engine soft reset.
    // Host SW can program this bit to 0b1 if the bit CSR_CE2HOST_STATUS.CE_DMA_STS is read as 0b11.
    // De-assertion of this bit is by copy engine
    // 

    uint64_t f_Reserved : 63;
    // Reserved
  };
} CSR_CE_SFTRST;

// Copy engine scratchpad register
#define CSR_HPS_SCRATCHPAD_OFFSET 0x150
typedef union _CSR_HPS_SCRATCHPAD {
  uint32_t value;
  struct {
    uint32_t f_HSP_SCRATCHPAD : 32;
    // Used during board bring up
  };
} CSR_HPS_SCRATCHPAD;

// DMA Done Flag
#define CSR_HOST2HPS_IMG_XFR_SHDW_OFFSET 0x154
typedef union _CSR_HOST2HPS_IMG_XFR_SHDW {
  uint32_t value;
  struct {
    uint32_t f_HOST2HPS_IMG_XFR_SHDW : 1;
    // 0: Complete Image size not copied from Host to HPS
    // 1: Complete image size copied from Host to HPS.
    // HPS can start SSBL verification.
    // HPS can poll this register to see if complete image is transferred from Host to HPS.
    // Once this field is found HIGH, HPS can start SSBL verification

    uint32_t f_Reserved : 31;
    // Reserve
  };
} CSR_HOST2HPS_IMG_XFR_SHDW;

// HPS Status
#define CSR_HPS2HOST_RSP_OFFSET 0x158
typedef union _CSR_HPS2HOST_RSP {
  uint32_t value;
  struct {
    uint32_t f_SSBL_VFY : 2;
    // SSBL Verification
    // 00: reset value
    // 01: successful SSBL verification
    // 10: Erroneous
    // 11: Rsvd
    // The image that is downloaded from host includes the following:
    // * Second Stage bootloader / uBoot
    // * Linux kernel + rootFS (includes the 1588 application)
    // Host will send this complete package to HPS DDR using the copy engine
    // This field depicts the SSBL Verification status. Once HPS sees host2hps
    // gpio (input to HPS) as high, HPS can issue read to HPS DDR and then start SSBL verification

    uint32_t f_KERNEL_VFY : 2;
    // Kernel Verification
    // 00: reset value
    // 01: successful Kernel verification
    // 10: Erroneous
    // 11: Rsvd
    // The image that is downloaded from host includes the following:
    // * Second Stage bootloader / uBoot
    // * Linux kernel + rootFS (includes the 1588 application)
    // Host will send this complete package to HPS DDR using the copy engine
    // This field depicts the Kernel verification status. Kernel verification is done after SSBL

    uint32_t f_HPS_RDY : 1;
    // HPS Ready.
    // HPS writes to this field once it is done with FSBL and ready to receive SSBL image.
    // HPS can program this bit only one time.
    // The first write to this field is expected as 1'b1.
    // No further programming will be allowed.

    uint32_t f_Reserved : 27;
    // Reserved
  };
} CSR_HPS2HOST_RSP;


typedef struct _ofs_cpeng {
  fpga_handle handle;
  volatile CE_FEATURE_DFH *r_CE_FEATURE_DFH;
  volatile CE_FEATURE_GUID_L *r_CE_FEATURE_GUID_L;
  volatile CE_FEATURE_GUID_H *r_CE_FEATURE_GUID_H;
  volatile CE_FEATURE_CSR_ADDR *r_CE_FEATURE_CSR_ADDR;
  volatile CE_FEATURE_CSR_SIZE_GROUP *r_CE_FEATURE_CSR_SIZE_GROUP;
  volatile CSR_HOST_SCRATCHPAD *r_CSR_HOST_SCRATCHPAD;
  volatile CSR_CE2HOST_DATA_REQ_LIMIT *r_CSR_CE2HOST_DATA_REQ_LIMIT;
  volatile CSR_SRC_ADDR *r_CSR_SRC_ADDR;
  volatile CSR_DST_ADDR *r_CSR_DST_ADDR;
  volatile CSR_DATA_SIZE *r_CSR_DATA_SIZE;
  volatile CSR_HOST2CE_MRD_START *r_CSR_HOST2CE_MRD_START;
  volatile CSR_CE2HOST_STATUS *r_CSR_CE2HOST_STATUS;
  volatile CSR_HOST2HPS_IMG_XFR *r_CSR_HOST2HPS_IMG_XFR;
  volatile CSR_HPS2HOST_RSP_SHDW *r_CSR_HPS2HOST_RSP_SHDW;
  volatile CSR_CE_SFTRST *r_CSR_CE_SFTRST;
  volatile CSR_HPS_SCRATCHPAD *r_CSR_HPS_SCRATCHPAD;
  volatile CSR_HOST2HPS_IMG_XFR_SHDW *r_CSR_HOST2HPS_IMG_XFR_SHDW;
  volatile CSR_HPS2HOST_RSP *r_CSR_HPS2HOST_RSP;
} ofs_cpeng;

int ofs_cpeng_init(ofs_cpeng *drv, fpga_handle h)
{
  uint8_t *ptr = 0;
  fpga_result res = fpgaMapMMIO(h, 0, (uint64_t**)&ptr);
  if (res) {
    return res;
  }
  drv->handle = h;
  drv->r_CE_FEATURE_DFH =
    (volatile CE_FEATURE_DFH*)(ptr+CE_FEATURE_DFH_OFFSET);
  drv->r_CE_FEATURE_GUID_L =
    (volatile CE_FEATURE_GUID_L*)(ptr+CE_FEATURE_GUID_L_OFFSET);
  drv->r_CE_FEATURE_GUID_H =
    (volatile CE_FEATURE_GUID_H*)(ptr+CE_FEATURE_GUID_H_OFFSET);
  drv->r_CE_FEATURE_CSR_ADDR =
    (volatile CE_FEATURE_CSR_ADDR*)(ptr+CE_FEATURE_CSR_ADDR_OFFSET);
  drv->r_CE_FEATURE_CSR_SIZE_GROUP =
    (volatile CE_FEATURE_CSR_SIZE_GROUP*)(ptr+CE_FEATURE_CSR_SIZE_GROUP_OFFSET);
  drv->r_CSR_HOST_SCRATCHPAD =
    (volatile CSR_HOST_SCRATCHPAD*)(ptr+CSR_HOST_SCRATCHPAD_OFFSET);
  drv->r_CSR_CE2HOST_DATA_REQ_LIMIT =
    (volatile CSR_CE2HOST_DATA_REQ_LIMIT*)(ptr+CSR_CE2HOST_DATA_REQ_LIMIT_OFFSET);
  drv->r_CSR_SRC_ADDR =
    (volatile CSR_SRC_ADDR*)(ptr+CSR_SRC_ADDR_OFFSET);
  drv->r_CSR_DST_ADDR =
    (volatile CSR_DST_ADDR*)(ptr+CSR_DST_ADDR_OFFSET);
  drv->r_CSR_DATA_SIZE =
    (volatile CSR_DATA_SIZE*)(ptr+CSR_DATA_SIZE_OFFSET);
  drv->r_CSR_HOST2CE_MRD_START =
    (volatile CSR_HOST2CE_MRD_START*)(ptr+CSR_HOST2CE_MRD_START_OFFSET);
  drv->r_CSR_CE2HOST_STATUS =
    (volatile CSR_CE2HOST_STATUS*)(ptr+CSR_CE2HOST_STATUS_OFFSET);
  drv->r_CSR_HOST2HPS_IMG_XFR =
    (volatile CSR_HOST2HPS_IMG_XFR*)(ptr+CSR_HOST2HPS_IMG_XFR_OFFSET);
  drv->r_CSR_HPS2HOST_RSP_SHDW =
    (volatile CSR_HPS2HOST_RSP_SHDW*)(ptr+CSR_HPS2HOST_RSP_SHDW_OFFSET);
  drv->r_CSR_CE_SFTRST =
    (volatile CSR_CE_SFTRST*)(ptr+CSR_CE_SFTRST_OFFSET);
  drv->r_CSR_HPS_SCRATCHPAD =
    (volatile CSR_HPS_SCRATCHPAD*)(ptr+CSR_HPS_SCRATCHPAD_OFFSET);
  drv->r_CSR_HOST2HPS_IMG_XFR_SHDW =
    (volatile CSR_HOST2HPS_IMG_XFR_SHDW*)(ptr+CSR_HOST2HPS_IMG_XFR_SHDW_OFFSET);
  drv->r_CSR_HPS2HOST_RSP =
    (volatile CSR_HPS2HOST_RSP*)(ptr+CSR_HPS2HOST_RSP_OFFSET);
  return 0;
}



// *****  function prototypes ******//
int ofs_cpeng_wait_for_hps_ready(ofs_cpeng *drv, uint64_t timeout_usec);
int ofs_cpeng_dma_status(ofs_cpeng *drv);
bool ofs_cpeng_dma_status_idle(ofs_cpeng *drv);
bool ofs_cpeng_dma_status_success(ofs_cpeng *drv);
bool ofs_cpeng_dma_status_error(ofs_cpeng *drv);
int ofs_cpeng_ce_axist_cpl_sts(ofs_cpeng *drv);
int ofs_cpeng_ce_acelite_bresp_sts(ofs_cpeng *drv);
int ofs_cpeng_ce_fifo1_status(ofs_cpeng *drv);
int ofs_cpeng_ce_fifo2_status(ofs_cpeng *drv);
int ofs_cpeng_hps_kernel_verify(ofs_cpeng *drv);
int ofs_cpeng_hps_ssbl_verify(ofs_cpeng *drv);
uint64_t ofs_cpeng_hps2host_rsp(ofs_cpeng *drv);
void ofs_cpeng_ce_soft_reset(ofs_cpeng *drv);
void ofs_cpeng_image_complete(ofs_cpeng *drv);
void ofs_cpeng_set_data_req_limit(ofs_cpeng *drv, uint8_t value);
int ofs_cpeng_copy_chunk(ofs_cpeng *drv, uint64_t iova, uint64_t offset, uint32_t size, uint64_t timeout_usec);
int ofs_cpeng_copy_image(ofs_cpeng *drv, uint64_t iova, uint64_t offset, uint32_t size, uint32_t chunk, uint64_t timeout_usec);


// *****  function implementations ******//
int ofs_cpeng_wait_for_hps_ready(ofs_cpeng *drv, uint64_t timeout_usec)
{
	return OFS_WAIT_FOR_EQ(drv->r_CSR_HPS2HOST_RSP_SHDW->f_HPS_RDY_SHDW, 1, timeout_usec, 100);
}

int ofs_cpeng_dma_status(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_DMA_STS;
}

bool ofs_cpeng_dma_status_idle(ofs_cpeng *drv)
{
	return ofs_cpeng_dma_status(drv) == 0;
}

bool ofs_cpeng_dma_status_success(ofs_cpeng *drv)
{
	return ofs_cpeng_dma_status(drv) == 2;
}

bool ofs_cpeng_dma_status_error(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_DMA_STS == 3;
}

int ofs_cpeng_ce_axist_cpl_sts(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_AXIST_CPL_STS;
}

int ofs_cpeng_ce_acelite_bresp_sts(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_ACELITE_BRESP_STS;
}

int ofs_cpeng_ce_fifo1_status(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_FIFO1_STS;
}

int ofs_cpeng_ce_fifo2_status(ofs_cpeng *drv)
{
	return drv->r_CSR_CE2HOST_STATUS->f_CE_FIFO2_STS;
}

int ofs_cpeng_hps_kernel_verify(ofs_cpeng *drv)
{
	return drv->r_CSR_HPS2HOST_RSP_SHDW->f_KERNEL_VFY_SHDW;
}

int ofs_cpeng_hps_ssbl_verify(ofs_cpeng *drv)
{
	return drv->r_CSR_HPS2HOST_RSP_SHDW->f_SSBL_VFY_SHDW;
}

uint64_t ofs_cpeng_hps2host_rsp(ofs_cpeng *drv)
{
	return drv->r_CSR_HPS2HOST_RSP_SHDW->value;
}

void ofs_cpeng_ce_soft_reset(ofs_cpeng *drv)
{
	drv->r_CSR_CE_SFTRST->f_CE_SFTRST = 1;
}

void ofs_cpeng_image_complete(ofs_cpeng *drv)
{
	drv->r_CSR_HOST2HPS_IMG_XFR->f_HOST2HPS_IMG_XFR = 1;
}

void ofs_cpeng_set_data_req_limit(ofs_cpeng *drv, uint8_t value)
{
	drv->r_CSR_CE2HOST_DATA_REQ_LIMIT->f_DATA_REQ_LIMIT = value;
}

int ofs_cpeng_copy_chunk(ofs_cpeng *drv, uint64_t iova, uint64_t offset, uint32_t size, uint64_t timeout_usec)
{
	drv->r_CSR_SRC_ADDR->f_CSR_SRC_ADDR = iova;
	drv->r_CSR_DST_ADDR->f_CSR_DST_ADDR = offset;
	drv->r_CSR_DATA_SIZE->f_CSR_DATA_SIZE = size;
	drv->r_CSR_HOST2CE_MRD_START->f_MRD_START = 1;
	if (OFS_WAIT_FOR_NE(drv->r_CSR_CE2HOST_STATUS->f_CE_DMA_STS, 1, timeout_usec, 100)) {
		OFS_ERR("timed out waiting for DMA_STS");
		return 1;
	}
	if (ofs_cpeng_dma_status_success(drv)) {
		return 0;
	}
	OFS_ERR("dma status not successful");
	return 1;
}

int ofs_cpeng_copy_image(ofs_cpeng *drv, uint64_t iova, uint64_t offset, uint32_t size, uint32_t chunk, uint64_t timeout_usec)
{
	if (!chunk) {
		return ofs_cpeng_copy_chunk(drv, iova, offset, size, timeout_usec);
	}
	uint32_t ptr = 0;
	uint64_t local_timeout = timeout_usec/chunk;
	while (ptr < size) {
		if (ofs_cpeng_copy_chunk(drv, iova+ptr, offset+ptr, chunk, local_timeout)) {
			return 1;
		}
		ptr += chunk;
		if (size-ptr < chunk) {
			chunk = size-ptr;
		}
		if (OFS_WAIT_FOR_EQ(drv->r_CSR_HOST2CE_MRD_START->f_MRD_START, 0, local_timeout, 100)) {
			OFS_ERR("timed out waiting for MRD_START");
			return 1;
		}
	}
	ofs_cpeng_image_complete(drv);
	return 0;
}


#ifdef __cplusplus
}
#endif

#endif //  __ofs_cpeng__
